#!/system/bin/busybox sh

# prevent segfault by some android apps
export LD_LIBRARY_PATH=/system/lib

MAX_FREQ_FILE="/sys/devices/system/cpu/cpu0/cpufreq/scaling_max_freq"
GOV_FILE="/sys/devices/system/cpu/cpu0/cpufreq/scaling_governor"

SYSTEM_MAX_FREQ=`cat $MAX_FREQ_FILE`
FREQ_PS=864000

# conservative after performance by default
echo "conservative" > $GOV_FILE
echo 100000 > /sys/devices/system/cpu/cpufreq/conservative/sampling_rate

while [ true ]; do

PROP_SCALE=`getprop persist.cpumode.mode`

if [ -z "$PROP_SCALE" ]; then
	PROP_SCALE="disable"
	setprop persist.cpumode.mode $PROP_SCALE
fi

if [ "$PROP_SCALE" != 'disable' ]; then
	CUR_GOV=`cat $GOV_FILE`
	CUR_MAX_FREQ=`cat $MAX_FREQ_FILE`
	
	PROP_GOV=`getprop persist.cpumode.gov`
	PROP_FREQ=`getprop persist.cpumode.freq`

	if [ -z "$PROP_GOV" ]; then
		PROP_GOV="conservative"
		setprop persist.cpumode.gov $PROP_GOV
	fi

	if [ -z "$PROP_FREQ" ]; then
		PROP_FREQ=$SYSTEM_MAX_FREQ
		setprop persist.cpumode.freq $PROP_FREQ
	fi

	if [ $PROP_FREQ -gt $SYSTEM_MAX_FREQ ]; then
		PROP_FREQ=$SYSTEM_MAX_FREQ
	fi

# conf check
	if [ ! -z "$PROP_SCALE" ]; then
		if [ "$PROP_SCALE" = 'normal' ] && [ "$CUR_MAX_FREQ" != "$SYSTEM_MAX_FREQ" ]; then
			echo $SYSTEM_MAX_FREQ > $MAX_FREQ_FILE
			echo 333000 > /sys/class/mali_freq/max
			echo 0 > /sys/devices/system/cpu/sched_mc_power_savings
		fi
	
		if [ "$PROP_SCALE" = 'powersave' ] && [ "$CUR_MAX_FREQ" != "$FREQ_PS" ]; then
			echo $FREQ_PS > $MAX_FREQ_FILE
			echo 250000 > /sys/class/mali_freq/max
			echo 1 > /sys/devices/system/cpu/sched_mc_power_savings
		fi
	
		if [ "$PROP_SCALE" = 'manual' ] && [ "$CUR_MAX_FREQ" != "$PROP_FREQ" ]; then
			echo $PROP_FREQ > $MAX_FREQ_FILE
			echo 333000 > /sys/class/mali_freq/max
			echo 0 > /sys/devices/system/cpu/sched_mc_power_savings
		fi
	fi

	if [ ! -z "$PROP_GOV" ] && [ "$PROP_GOV" != "$CUR_GOV" ]; then
		if [ "$PROP_GOV" = 'interactive' ]; then
			echo ondemand > $GOV_FILE
			echo 50000 > /sys/devices/system/cpu/cpufreq/ondemand/sampling_rate
		else
			echo conservative > $GOV_FILE
			echo 100000 > /sys/devices/system/cpu/cpufreq/conservative/sampling_rate
		fi
	fi
fi

sleep 5

done

# always exit with status 0
exit 0
