#!/system/bin/busybox sh

# prevent segfault by some android apps
export LD_LIBRARY_PATH=/system/lib

if [ ! -e /data/system.notgpsinit ]; then
    rm -fR /data/app/ing
    mkdir /data/app/ing 
    chmod 775 /data/app/ing 
    chown 1000:1000 /data/app/ing 
    cp /system/etc/Orion.ini /data/app/ing/Orion.ini
	 chmod 644 /data/app/ing/Orion.ini
    touch /data/system.notgpsinit
    sync
fi

mkfifo /dev/gpsr
mkfifo /dev/gpsw
chmod 0600 /dev/ttyS2
chown 0:0 /dev/ttyS2


GPS_ENABLE=`getprop gps.enable`
if [ "$GPS_ENABLE" != "true" ]; then
    exit 0
fi

START="0"
ACTIVE="0"
echo off > /sys/class/gps_power/gps_powerctrl

while [ true ]; do
 if [ -e /data/app/ing/custom.conf ]; then
	CFG=`cat /data/app/ing/custom.conf`
	POS=1
	RULE=""

	for SET in $CFG ; do
		case $POS in
		1)
		RULE="s/PinningPositionThreshold=.*$/PinningPositionThreshold=$SET/;"
		;;
		2)
		RULE="$RULE s/PinningVelocityThreshold=.*$/PinningVelocityThreshold=$SET/;"
		;;
		3)
		RULE="$RULE s/HdopThreshold=.*$/HdopThreshold=$SET/;"
		;;
		4)
		RULE="$RULE s/MinSignalCN0=.*$/MinSignalCN0=$SET/;"
		;;
		5)
		RULE="$RULE s/AlgorithmSbas=.*$/AlgorithmSbas=$SET/;"
		;;
		6)
		RULE="$RULE s/AlgorithmPrefilter=.*$/AlgorithmPrefilter=$SET/;"
		;;
		7)
		RULE="$RULE s/AlgorithmPostFilter=.*$/AlgorithmPostFilter=$SET/;"
		;;
		8)
		RULE="$RULE s/DRspeedDecay=.*$/DRspeedDecay=$SET/;"
		;;
		9)
		RULE="$RULE s/DRspeedLimit=.*$/DRspeedLimit=$SET/;"
		;;
		10)
		RULE="$RULE s/DRtimeLimitLow=.*$/DRtimeLimitLow=$SET/;"
		;;
		11)
		RULE="$RULE s/DRspeedLimit=.*$/DRspeedLimit=$SET/;"
		;;
		12)
		RULE="$RULE s/SetSystemTime=.*$/SetSystemTime=$SET/;"
		;;
		esac
		POS=`expr $POS + 1`
	done

	sed -i "$RULE" /data/app/ing/Orion.ini
	rm -f /data/app/ing/custom.conf
	rm -f /data/app/ing/fsh.*
	killall -9 ingsvcd 1>/dev/null 2>/dev/null
	START="1"
 fi
 
 if [ -e /data/app/ing/ctl ]; then
	CMD=`cat /data/app/ing/ctl`
	rm -f /data/app/ing/ctl
	
	killall -9 ingsvcd 1>/dev/null 2>/dev/null
	
	if [ "$CMD" = 'stop' ]; then
		START="0"
		ACTIVE="0"
		echo off > /sys/class/gps_power/gps_powerctrl
	fi
	
	if [ "$CMD" = 'start' ]; then
		START="1"
		ACTIVE="1"
	fi
 fi
 
 if [ "$START" = '1' -a "$ACTIVE" = '1' ]; then
	 START="0"
	 /system/bin/ingsvcd &
 fi
 
 sleep 2
done


# always exit with status 0
exit 0
